/////////////////////////////////////////////////////////////////////
// Lite-C program for controlling a device programmer or NETPORT
// by sending command scripts to the socket
// (c) 2011 Conitec
//
// remote.exe [script.gxs] [logfile.log] [-nwnd] [replacement1] [replacement2] [replacement3]
// order of parameters matters; GalepX programm must be started before
//////////////////////////////////////////////////////////////////////
#include <default.c>
#include <strio.c>

STRING* strScript = // default script that lets GALEP blink
"#include \"gxAPI/gxBasic1.h\"
string s = gxGetCurrentEndDevice();
gxDeviceIdentity(s);
";

STRING* cmd_parse(STRING* to)
{
	to = str_parse(to,command_str,0);
	if (to) // skip -nnn options
		while ('-' == str_getchr(to,1)) 
			if (!str_parse(to,command_str,0))
				return NULL;
	return to;
}

function main()
{
	video_screen = 0; // no engine window required
	video_window(NULL,NULL,112,NULL); // small border
	wait(1);
	if(dplay_port == 2300) dplay_port = 1233;
	if(str_cmpi(server_name,"")) str_cpy(server_name,"localhost");
	printf("Remote 1.40 -  ip: %s port: %i",_chr(server_name),(int)dplay_port);
	printf("\nSyntax: remote [options] [*.gxs] [*.log] [replace1] [replace2] [replace3]");
	printf("\nOptions: [-nwnd] [-ipnnn.nnn.nnn.nnn] [-portnnnn]\n");
   
// get the script filename from the command line
   STRING* name = str_parse_tail(NULL,command_str,".gxs");
   var script = 0;
   if (name) {
      script = file_open_read(name);
      if (script) {
         file_str_readto(script,strScript,"",10000);
         printf("\nScript: %s",_chr(name));
      }
      else printf("\nScript %s not found\n",_chr(name));
   }   
      
// get the log filename from the command line   
   var logf = 0;
   name = str_parse_tail(NULL,command_str,".log");
   if (name) {
      logf = file_open_write(name);
      if (logf) printf(" >> %s",_chr(name));
   }
   
 // no window?  
   var nowin = str_stri(command_str,"-nwnd");
   
// replace script keywords through the command line
	STRING* replacement = cmd_parse(NULL);
	if (replacement)
	  str_replaceall(strScript,"%1",replacement);
	if (cmd_parse(replacement))
	  str_replaceall(strScript,"%2",replacement);
	if (cmd_parse(replacement))
	  str_replaceall(strScript,"%3",replacement);

// replace missing parameters with empty strings
  str_replaceall(strScript,"%1","");
  str_replaceall(strScript,"%2","");
  str_replaceall(strScript,"%3","");

// open a TCP socket on port 1233 
   if (!socket_connect(server_name,dplay_port,1))
     printf("\nCan't connect to socket!\n");
   else
   {
// send the script to the socket
	   var sent = socket_send(_chr(strScript),str_len(strScript));
	   if (sent) printf("\n%s\n",_chr(strScript));
	   
// display the response   
	   char input[1001];
	   while(1) 
	   {
	      wait(1);
	      var received = socket_receive(input,1000);
	      if (received > 0) 
	      {
					input[received] = 0;
					printf(input);
// print into logfile and exit on error or success				
		      if (logf)
		        file_str_write(logf,input);
		      if (logf || nowin) {
		        if (str_stri(input,"#01")) // error code -> ERRORLEVEL 1
		         	sys_exit("1");
		        if (str_stri(input,"#00")) // success code
		         	sys_exit("Ok!");
		      }
		      
// generate exit code when token found	      
		      var pos = str_stri(input,"exitcode");
		      if (pos) { // exitcode -> ERRORLEVEL
		      	STRING* exitcode = str_create(input);
		      	str_clip(exitcode,pos+7);
		      	sys_exit(exitcode);
	      	}
	      }
	   }
	}
}
